/* **************************************************************************

    Filename: TScanDir
    Author:   Reiner Rosin
    Version:  1.00 (11-29-98)

    email:    reiner_rosin@wiesbaden-online.de
    www:      http://home.wiesbaden-online.de/~rrosin/sw

    Component for scanning directories and subdirectories for files
    matching a certain file mask

    History:
    --------
    1.00 (11-29-98)  First release

************************************************************************** */

//---------------------------------------------------------------------------
#ifndef TScanDirH
#define TScanDirH
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>
//---------------------------------------------------------------------------
namespace Tscandir
{
/*
typedef struct
{
	AnsiString pfad;       // Nur der Pfad, abgeschlossen mit Backslash
    AnsiString name;       // Dateiname mit Endung
    AnsiString ganz;       // Pfad mit Name
    AnsiString nameOnly;   // Dateiname ohne Endung
    AnsiString extension; // Dateiendung (ohne .)
    long laenge;           // Dateilnge in Bytes
} DATEI;

typedef struct
{
	AnsiString pfad;   // nur der bergeordnete Pfad, abgeschlossen mit Backslash
    AnsiString name; // Ordnername, ohne Pfad, ohne Backslash
    AnsiString ganz;   // Pfad mit Ordner und Backslash
} ORDNER;
*/
typedef struct
{
	AnsiString Path;       // The path, including final backslash, e.g. c:\\temp\\
    AnsiString Filename;   // Filename with extension, e.g. myfile.doc
    AnsiString FullName;   // Filename with path, e.g. c:\\temp\\myfile.doc
    AnsiString NameOnly;   // Filename without extension, e.g. myfile
    AnsiString Extension;  // Extension without ".", e.g. doc
    long Length;           // Filelength in bytes
} SCANDIRFILE;

typedef struct
{
	AnsiString Path;       // Parent path, including final backslash, e.g. c:\\temp\\
    AnsiString Foldername; // Foldername, no path, no backslashes, e.g. myfolder
    AnsiString FullName;   // Foldername with path and backslash, e.g. c:\\temp\\myfolder\\
} SCANDIRFOLDER;


typedef void __fastcall (__closure *TFileEvent)(System::TObject* Sender, SCANDIRFILE &scandirfile);
typedef void __fastcall (__closure *TFolderEvent)(System::TObject* Sender, SCANDIRFOLDER &folder);
typedef void __fastcall (__closure *TFolderProcessedEvent)(System::TObject* Sender, SCANDIRFOLDER &folder);

class PACKAGE TScanDir : public TComponent
{
public:
    __fastcall TScanDir(TComponent* Owner);
	void __fastcall Execute(void);
    int FolderCount;
    int FileCount;
private:
	TFileEvent FOnFileFound;
	TFolderEvent FOnFolderFound;
	TFolderProcessedEvent FOnFolderProcessed;
    AnsiString path;
    AnsiString mask;
    bool recursive;
	void __fastcall ScanDir(AnsiString path,AnsiString mask);
__published:
	__property TFileEvent OnFileFound = {read=FOnFileFound, write=FOnFileFound};
	__property TFolderEvent OnFolderFound = {read=FOnFolderFound, write=FOnFolderFound};
	__property TFolderProcessedEvent OnFolderProcessed = {read=FOnFolderProcessed, write=FOnFolderProcessed};
    __property AnsiString Path ={read=path, write=path};
    __property bool RecursiveScan ={read=recursive, write=recursive};
    __property AnsiString Mask ={read=mask, write=mask};
};

} // namespace ScanDir
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Tscandir;
#endif

#endif




